;SRK_bootLoader - MBR code of a PC-XINU bootable floppy disc
;Authors: SRK
;NASM version
;
;-----------------------------------------------------------------------------------------------------------------
;To be compiled using NASM using command
;	nasm -f bin -o SRK_bootLoader SRK_bootLoader.asm
;
;Once compiled, the resulting file goes into the first sector of the floppy
;The program argWrite takes care of writing to the floppy in the required format

;-----------------------------------------------------------------------------------------------------------------
%define LOC_STK 0x9000
%define LOC_CHNLDR 0x07E0

%define CHNLDR_START_SEC 2
%define CHNLDR_NUM_SEC 2

;-----------------------------------------------------------------------------------------------------------------
[ORG 7C00h]			;this is where the bios calls the MBR code
entry:

	mov ax,LOC_STK
	mov ss,ax
	mov sp,0		;initial stack setup at LOC_STK:0

	mov ax,LOC_CHNLDR
	mov es,ax
	mov bx,0		;header load location at LOC_HEADER:0

	mov dl,0		;drive number
	mov dh,0		;head number
	mov ch,0		;cylinder number
	mov cl,CHNLDR_START_SEC	;starting sector
	mov al,CHNLDR_NUM_SEC	;number of sectors to read
	mov ah,2
	int 0x13		;read disk

	pushf			;flag values when chain-loader takes over
	push LOC_CHNLDR		;segment location
	push 0			;offset location

	iret			;this is a method to transfer control (push flags,cs,ip values. iret pops them)

;-----------------------------------------------------------------------------------------------------------------
